package com.ywt.mg.web.controllers.hospital;

import com.ywt.mg.core.MGRight;
import com.ywt.mg.core.utils.Checker;
import com.ywt.mg.core.utils.serializers.JsonSerializer;
import com.ywt.mg.domain.models.ConstantDef;
import com.ywt.mg.params.offline.DownloadOfflineListNewRequest;
import com.ywt.mg.services.AuthService;
import com.ywt.mg.services.DownloadRecordService;
import com.ywt.mg.services.IdGenerator;
import com.ywt.mg.services.OfflineNewService;
import com.ywt.mg.web.BaseResponse;
import com.ywt.mg.web.controllers.OfflineController;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

@RestController("/hosp/offline")
@RequestMapping({"/hosp/offline"})
@MGRight
public class HospOfflineController {

    private static Logger logger = LoggerFactory.getLogger(HospOfflineController.class);

    @Autowired
    private AuthService authService;

    @Autowired
    private OfflineNewService offlineNewService;

    @Autowired
    private IdGenerator idGenerator;

    @Autowired
    private DownloadRecordService downloadRecordService;


    @RequestMapping({"/downloadOfflineList"})
    public BaseResponse downloadOfflineList(@RequestBody DownloadOfflineListNewRequest request) {
        int currentAdminId = Checker.getIntegerValue(authService.getCurrentAdminId());
        request.setCurrentAdminId(currentAdminId);
        // 插入记录
        int  hospital = authService.getCurrentHospitalId();
        request.setHospitalId(hospital);
        int downloadRecordId = idGenerator.genDownloadRecordId();
        String name = "线下就诊";
        String fileName = "线下就诊";
        String excelSuffixFormat = ConstantDef.EXCEL_SUFFIX_FORMAT;
        String paramUrl = "/hosp/offline/downloadOfflineList";
        String paramJson = JsonSerializer.toJson(request);
        downloadRecordService.getOrInsertDownloadRecordByHosp(downloadRecordId, name, fileName + excelSuffixFormat, paramUrl, paramJson);
        Thread t = new Thread() {
            @Override
            public void run() {
                offlineNewService.downloadOfflineListCommon(downloadRecordId, fileName, request);
            }
        };
        t.start();
        return new BaseResponse().succeed("后台下载中...");
    }

}
